unit hiWinBorders;

interface

uses Kol,Share,Debug,Windows;

type
  THIWinBorders = class(TDebug)
   private
    procedure SetBorderStyle(h, Value:Cardinal);
    procedure SetWinStyle(h, Value:Cardinal);
   public
    _prop_BorderStyle:byte;
    _prop_WinStyle:byte;

    _data_Handle:THI_Event;

    procedure _work_doSetBorderStyle(var _Data:TData; Index:word);
    procedure _work_doSetWinStyle(var _Data:TData; Index:word);
  end;

implementation

procedure THIWinBorders.SetBorderStyle;
const
  NmMask = not(WS_CAPTION or WS_THICKFRAME or WS_MAXIMIZEBOX or WS_MINIMIZEBOX);
  NmSet:array[0..9] of integer =(0,
      WS_CAPTION or WS_MINIMIZEBOX,
      WS_CAPTION or WS_THICKFRAME or WS_MAXIMIZEBOX or WS_MINIMIZEBOX,
      WS_CAPTION,
      WS_CAPTION,
      WS_CAPTION or WS_THICKFRAME,
      0,
      WS_THICKFRAME,
      0,
      WS_THICKFRAME
  );
  
  ExMask = not(WS_EX_DLGMODALFRAME or WS_EX_WINDOWEDGE or WS_EX_TOOLWINDOW or WS_EX_CLIENTEDGE);
  ExSet:array[0..9] of integer =(0,0,0,
      WS_EX_WINDOWEDGE,
      WS_EX_TOOLWINDOW,
      WS_EX_TOOLWINDOW,
      WS_EX_DLGMODALFRAME,
      WS_EX_TOOLWINDOW,
      WS_EX_CLIENTEDGE or WS_EX_DLGMODALFRAME,
      WS_EX_CLIENTEDGE
  );
begin
  if Value > 9 then exit;
  SetWindowLong(h, GWL_STYLE, NmSet[Value] or (NmMask and GetWindowLong(h, GWL_STYLE)));
  SetWindowLong(h, GWL_EXSTYLE, ExSet[Value] or (ExMask and GetWindowLong(h, GWL_EXSTYLE)));
  SetWindowPos(h, 0, 0,0,0,0, SWP_FRAMECHANGED or SWP_NOMOVE or SWP_NOSIZE or SWP_NOZORDER or SWP_NOOWNERZORDER);
end;

procedure THIWinBorders.SetWinStyle;
const
  ExMask = not(WS_EX_DLGMODALFRAME or WS_EX_CLIENTEDGE or WS_EX_LTRREADING or WS_EX_STATICEDGE);
  ExSet:array[0..4] of integer =(
      WS_EX_CLIENTEDGE,
      WS_EX_LTRREADING,
      WS_EX_STATICEDGE,
      WS_EX_DLGMODALFRAME,
      WS_EX_CLIENTEDGE or WS_EX_DLGMODALFRAME
  );
begin
  if Value > 4 then exit;
  SetWindowLong(h, GWL_EXSTYLE, ExSet[Value] or (ExMask and GetWindowLong(h, GWL_EXSTYLE)));
  SetWindowPos(h, 0, 0,0,0,0, SWP_FRAMECHANGED or SWP_NOMOVE or SWP_NOSIZE or SWP_NOZORDER or SWP_NOOWNERZORDER);
end;

procedure THIWinBorders._work_doSetBorderStyle;
var h:cardinal;
    v:integer;
begin
  h := ReadInteger(_Data, _data_Handle);
  if _prop_BorderStyle = 2 then
    v := ToInteger(_Data)
  else
    v := ReadInteger(_Data, NULL, _prop_BorderStyle);
  SetBorderStyle(h, v);
end;

procedure THIWinBorders._work_doSetWinStyle;
var h:cardinal;
    v:integer;
begin
  h := ReadInteger(_Data, _data_Handle);
  if _prop_WinStyle = 1 then
    v := ToInteger(_Data)
  else
    v := ReadInteger(_Data, NULL, _prop_WinStyle);
  SetWinStyle(h, v);
end;

end.
